POJ 2356. Find a multiple 抽屉/鸽巢原理


Find a multiple

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 7192   Accepted: 3138   Special Judge

Description

The input contains N natural (i.e. positive integer) numbers ( N <= 10000 ). Each of that numbers is not greater than 15000. This numbers are not necessarily different (so it may happen that two or more of them will be equal). Your task is to choose a few of given numbers ( 1 <= few <= N ) so that the sum of chosen numbers is multiple for N (i.e. N * k = (sum of chosen numbers) for some natural number k).

Input

The first line of the input contains the single number N. Each of next N lines contains one number from the given set.

Output

In case your program decides that the target set of numbers can not be found it should print to the output the single number 0. Otherwise it should print the number of the chosen numbers in the first line followed by the chosen numbers themselves (on a separate line each) in arbitrary order.

If there are more than one set of numbers with required properties you should print to the output only one (preferably your favorite) of them.

Sample Input

5
1
2
3
4
1

Sample Output

2
2
3

Source

Ural Collegiate Programming Contest 1999

题目大意

  给定$N$个自然数,试找出其中的若干个数,它们的算术和是$N$的整数倍。

基本思路

  1、若存在$sum\%N==0$,则$sum$一定是$N$的倍数(即$sum==kN,\ k\in [1, \infty]$)。

  2、若$sum[i]\equiv sum[j]\ mod\ N$,则$(sum[j]-sum[i])\%N==0$,即$sum[j]-sum[i]$是$N$的倍数。

  3、(鸽巢原理)将$N$个物体放入$N-1$个盒子里,则一定至少有$1$个盒子放了$2$个以上的物体。这里我们将$N$个自然数分别记为$arr[i],\ i\in [1,\ N]$,令$sum[i]=(\sum\limits^{N}_{i=1}arr[i])\%N,\ i\in [1,\ N]$,而$sum[i]$的取值范围为0 ~ N-1,因此必然有:或者A.存在$i,\ j\in [1,\ N]$使得sum[i]==sum[j],或者B.存在$i\in [1,\ N]$有sum[i]==0。

  4、建立一个标记数组$sgn[]$,标记$sum[]$的值,这样可以在读入预处理时找到相等的两个$sum$。同时根据第3点,我们得知答案必然存在,不会出现没有答案输出0的情况。

  5、由于存在sum[i]==0的情况,所以要初始化sgn[0]=0。

代码

 1 #include <stdio.h>
 2 #include <string.h>
 3
 4 int N, arr[10010], sum[10010], sgn[10010];
 5
 6 int main() {
 7     int l=0, r=-1;
 8     memset(sgn, 0xFF, sizeof(sgn)); sgn[0]=0;
 9     scanf("%d", &N);
10     for(int i=1; i<=N; i++) {
11         scanf("%d", arr+i);
12         sum[i]=(sum[i-1]+arr[i])%N;
13         if(!~sgn[sum[i]])
14             sgn[sum[i]]=i;
15         else {
16             l=sgn[sum[i]];
17             r=i;
18         }
19     }
20     printf("%d\n", r-l);
21     for(int i=l+1; i<=r; i++)
22         printf("%d\n", arr[i]);
23     return 0;
24 }

POJ 2356

——本文原创by BlackStorm,转载请注明出处。

本文地址:http://www.cnblogs.com/BlackStorm/p/5243156.html

时间: 2024-10-18 14:35:08

POJ 2356. Find a multiple 抽屉/鸽巢原理的相关文章

poj 2356 Find a multiple(鸽巢原理)

Description The input contains N natural (i.e. positive integer) numbers ( N <= 10000 ). Each of that numbers is not greater than 15000. This numbers are not necessarily different (so it may happen that two or more of them will be equal). Your task i

poj 2356 Find a multiple【鸽巢原理 模板应用】

Find a multiple Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6651   Accepted: 2910   Special Judge Description The input contains N natural (i.e. positive integer) numbers ( N <= 10000 ). Each of that numbers is not greater than 15000

POJ2356 Find a multiple【鸽巢原理】

题目链接: http://poj.org/problem?id=2356 题目大意: 给你N个正数的序列,从中找到连续的若干数,使得其和刚好是N的倍数. 解题思路: 典型的抽屉原理. Sum[i]为序列中前i项的和.则有两种可能: 1.若有Sum[i]是N的倍数,则直接输出前i项. 2.如果没有任何的Sum[i]是N的倍数,则计算ri = Sum[i] % N.根据鸽巢原理,肯 定有Sum[i] % N == Sum[j] % N,i != j.则第 j 到第 i 项数的和即为N的倍数. AC代

POJ 2356 Find a multiple 抽屉原理

从POJ 2356来体会抽屉原理的妙用= =! 题意: 给你一个n,然后给你n个数,让你输出一个数或者多个数,让这些数的和能够组成n: 先输出一个数,代表有多少个数的和,然后再输出这些数: 题解: 首先利用前缀和先预处理一下,然后如果sum[i]==0的话,很显然就直接输出i,然后接下来从第一位一直输出到第i位就行了 然后接下来直接用一个mod数组表示上一个答案为这个mod的时候的编号是多少 就是mod[sum[i]%n]=i; 然后判断一下if(mod[sum[i]%n]!=0)然后就直接从m

POJ 题目3370 Halloween treats(鸽巢原理)

Halloween treats Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 7099   Accepted: 2621   Special Judge Description Every year there is the same problem at Halloween: Each neighbour is only willing to give a certain total number of sweets

poj 2356 Find a multiple 鸽巢原理的简单应用

题目要求任选几个自然数,使得他们的和是n的倍数. 由鸽巢原理如果我们只选连续的数,一定能得到解. 首先预处理前缀和模n下的sum,如果发现sum[i]==sum[j] 那么(sum[j]-sum[i])%n一定为0,直接输出i+1~j就够了. 为什么一定会有解,因为sum从1~n有n个数,而模n下的数只有0~n-1,把n个数放入0~n-1个数里,怎么也会有重复,所以这种构造方法一定没问题. 其实可以O(n)实现,嫌麻烦,就二重循环无脑了. #include <iostream> #includ

POJ 2356 Find a multiple 鸽巢原理

题目来源:POJ 2356 Find a multiple 题意:n个数 选出任意个数 使得这些数的和是n的倍数 思路:肯定有解 并且解是连续的一段数 证明: 假设有m个数 a1,a2,a3...am    s1 s2 s3...sm为前缀和 s1 = a1 s2 = a1+a2 s3 = a1+a2+a3... sm = a1+a2+a3+...+am 1.如果某个前缀和si%m == 0 那么得到解 2.设x1=s1%m x2 = s2%m x3 = s3%m xm = sm%m 因为1不成

POJ 2356 find multiple 鸽巢原理

我们在浏览一些网站,尤其是一些小说网站的时候,都会有修改页面背景颜色的地方,这个功能使用jquery很容易实现. 效果图: show you code: <!doctype html> <html> <head> <meta charset="utf-8"> <title>jquery test</title> <script src="jquery-1.11.1.min.js">&

Find a multiple POJ - 2356【鸽巢原理】

题意: 求在长度为 \(n\) 的数组中选择连续的元素,使其和是 \(n\) 的倍数,输出元素个数和每个元素的值. 分析: ??我们选取一段连续的元素.对原数组求前缀和,并且对 \(n\) 取模,那么结果就会分布在 \([0,n)\) 之间.如果有一个前缀和取模 \(n\) 的结果为 \(0\),那么这个前缀和一定满足条件.否则,我们考虑有 \(n\) 个结果,分布在长度为 \(n-1\) 的区间上,根据鸽巢原理,必然会有两个相同,那么这两个位置之间的元素和就满足条件. 代码: #include